﻿(function () {
    "use strict";

    var networkInfo = Windows.Networking.Connectivity.NetworkInformation;
    var networkConnectivityInfo = Windows.Networking.Connectivity.NetworkConnectivityLevel;

    WinJS.Namespace.define("Internet", {
        isConnected: isConnected,
        ifConnected: ifConnected
    });

    function isConnected() {
        var connectionProfile = networkInfo.getInternetConnectionProfile();
        if (connectionProfile == null) {
            return false;
        }

        var networkConnectivityLevel = connectionProfile.getNetworkConnectivityLevel();
        if (networkConnectivityLevel == networkConnectivityInfo.none
            || networkConnectivityLevel == networkConnectivityInfo.localAccess
            || networkConnectivityLevel == networkConnectivityInfo.constrainedInternetAccess) {
            return false;
        }

        return true;
    }

    function ifConnected(action) {
        if (isConnected())
            action();
    }

})();